/*
	$Id: pacman.h,v 1.4 1998/12/30 21:00:48 mbn Exp $

	------------------------------------------------------------------------
	ClanLib, the platform independent game SDK.

	This library is distributed under the GNU LIBRARY GENERAL PUBLIC LICENSE
	version 2. See COPYING for details.

	For a total list of contributers see CREDITS.

	------------------------------------------------------------------------

	File purpose:
		Small Pacman game. Main header file.

*/

#ifndef header_pacman
#define header_pacman

#include "fontblowup.h"

#define MAP_WIDTH 39
#define MAP_HEIGHT 31

class GameObject;
class GameObject_Pacman;

class PacManApplication : public CL_ClanApplication
{
protected:
	bool find_neightbor(int x, int y, int *x, int *y);

	void init_display();
	void init_map(int level);
	void init_objects();

	void run_game();

	void deinit();

public:
	int center_x, center_y;
	
	CL_ResourceManager *resources;

	CL_SoundBuffer *sfx_namnam;

	CL_Surface *sur_maptiles;
	CL_Surface *sur_pacman;
	CL_Surface *sur_ghost;
	CL_Surface *sur_bar;

	CL_Font *fnt_clansoft;

	CL_List<FontBlowUp> blowups;

	CL_List<GameObject> objects;
	GameObject_Pacman *player;
	int score;

	int map[MAP_WIDTH][MAP_HEIGHT];
	int nof_eggs;

	virtual char *get_title();
	virtual int main(int argc, char** argv);
};

#endif
